# recursion_practice_test.py
#L. Lee (LJL2), T. Sarver (TCS95)

import doll
import cornellasserts as ca
import recursion_practice as rp
import inspect
import copy

def test_sum_to_num():
    # Simple input
    ca.assert_equals(1, rp.sum_to_num(1))

    # Larger Input
    ca.assert_equals(15, rp.sum_to_num(5))
    ca.assert_equals(6, rp.sum_to_num(3))

    # Super Larger Input: Just for Fun
    ca.assert_equals(210, rp.sum_to_num(20))

def test_num_dolls():
    fn_name = inspect.stack()[0][3]
    # print("Running " + fn_name)

    d1 = doll.Doll("Dmitry", None)
    d2 = doll.Doll("Catherine", d1)
    d3 = doll.Doll("Boris", d2)
    d4 = doll.Doll("Aleksandr", d3)

    dolls = [d1, d2, d3, d4]
    copies = list(map(copy.deepcopy, dolls))

    for i in range(len(dolls)):
        # print("Running on doll named "+dolls[i].name)
        ca.assert_equals(i+1, rp.num_dolls(dolls[i]))

def test_embed():
    fn_name = inspect.stack()[0][3]
    # print("Running " + fn_name)
    ca.assert_equals(0, rp.embed('cs1110'))
    ca.assert_equals(1, rp.embed(['cs1110']))
    ca.assert_equals(1, rp.embed(['cs1110', 'opython', 'typoon']))
    ca.assert_equals(3,
                     rp.embed(['cs1110',
                                           ['opython', ['recursion'], 'typoon']]))

def test_prefix():
    testcases = [
        # format: (input, return value)
        ('abc', 1),
        ('xxxxxxyzx',  6),
        ('', 0),
        ('aab', 2)
        ]

    for item in testcases:
        s = item[0]
        expected = item[1]
        error_msg_start = "prefix problem " # prepare for any errors
        error_msg_start += "on input " + str(s) + ": "

        result = rp.prefix(s)
        assert result == expected, \
            error_msg_start + "expected output " + repr(expected) \
            + " but got " + repr(result)

def test_decode():
    testcases = [
        ([['a',3],['h',1],['a',1]], 'aaaha'),
        ([], '')
    ]

    for item in testcases:
        nlist = item[0]
        expected = item[1]
        orig_list = nlist[:]

        error_msg_start = "decode problem " # prepare for any errors
        error_msg_start += "on input " + str(nlist) + ": "

        result = rp.ecode(nlist)
        assert orig_list == nlist, "input list was changed to " + str(nlist)
        assert result == expected, "expected " + str(expected) + " but got " + str(result)



print("Starting tests!")
print("Testing sum_to_num")
test_sum_to_num()
print("Finished testing sum_to_num")
print()

print("Testing num_dolls")
test_num_dolls()
print("Finished testing num_dolls")
print()

print("Testing embed")
test_embed()
print("Finished testing embed")
print()

print("Testing prefix")
test_prefix()
print("Finished testing prefix")
print()

print("Testing decode")
test_prefix()
print("Finished testing decode")
print()

print("All functions passed! You have completed this recursion training!")
